#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>

int main(int argc, char *argv[])
{
	int fd;
	int pid;


	printf("PID=%d) I am forking\n", getpid());
	pid = fork();
	if (pid == 0)
	{
		printf("PID=%d) I am running 'ls'\n", getpid());
		execl("/bin/ls", "", NULL);
		exit(2);
	} 

	if(waitpid(pid, NULL, 0) < 0)
		printf("PID=%d) wait error (waiting PID %d)\n", getpid(), pid);
	else
		printf("PID=%d) wait succeeded (waiting PID %d)\n", getpid(), pid);


	printf("PID=%d) I am forking\n", getpid());
	pid = fork();    
	if (pid == 0){
		printf("PID=%d) I am opening a text file\n", getpid());
		fd=open("Chapter_03.txt", O_RDONLY);
		close(fd);
	}

	if(waitpid(pid, NULL, 0) < 0)  
		printf("PID=%d) wait error (waiting PID %d)\n", getpid(), pid);
	else
		printf("PID=%d) wait succeeded (waiting PID %d)\n", getpid(), pid);


	exit(0);
}
