#include <stdio.h>
#define fastcall	__attribute__((regparm(3)))

int fastcall setbits(int p1, int p2)
{
	printf("setbits(): p1=0x%x, p2=0x%x\n", p1, p2);
	return p1 | p2;
}

int foo(void)
{
	int ee = 0x4000, ce = 0x8000, reg;

	__asm__ __volatile__("movl %1, %%eax\n"
		"movl %2, %%ebx\n"
		"call setbits\n"
		"movl %%eax, %0\n"
		: "=r" (reg)   // reg [param %0] is output   
		: "r" (ce), "r"(ee)  // ce [param %1], ee [param %2] are inputs
		: "%eax" , "%ebx"   // %eax and % ebx got clobbered 
	);
	printf("reg=%x",reg);
}

int main()
{
	foo();
	printf("\n");
	return 0;
}

